package manage

import (
	"demo/configs"
	"demo/data/domain"
	"demo/data/domain/vo"
)

func GetGoodsTypeById(id int64) (domain.GoodsType, error) {
	var goodsType domain.GoodsType
	_, err := configs.Engine.Table("goods_type").Where("id = ?", id).Get(&goodsType)
	if err != nil {
		return goodsType, err
	}
	return goodsType, nil
}

func GetGoodsTypeListInId(ids []int64) ([]domain.GoodsType, error) {
	rows, err := configs.Engine.Table("goods_type").In("id", ids).Rows(&domain.GoodsType{})
	if err != nil {
		return make([]domain.GoodsType, 0), err
	}
	defer rows.Close()
	var list []domain.GoodsType
	for rows.Next() {
		var u domain.GoodsType
		rows.Scan(&u)
		list = append(list, u)
	}
	return list, nil
}

func GetGoodsTypeList(goodsType domain.GoodsType, pageNum, pageSize int) (vo.BaseListVo, error) {
	var arr []domain.GoodsType
	Count, err := configs.Engine.Table("goods_type").Limit(pageSize, (pageNum-1)*pageSize).FindAndCount(&arr, &goodsType)
	var vo vo.BaseListVo
	if err != nil {
		return vo, err
	}
	if err != nil {
		return vo, err
	}
	vo.PageNum = pageNum
	vo.PageSize = pageSize
	vo.List = make([]any, len(arr))
	for i, v := range arr {
		vo.List[i] = v
	}
	vo.Total = int(Count)
	return vo, nil
}

func SaveGoodsType(goodsType *domain.GoodsType) (domain.GoodsType, error) {
	_, err := configs.Engine.Table("goods_type").Insert(&goodsType)
	if err != nil {
		return *goodsType, err
	}
	return *goodsType, nil
}

func SetGoodsType(goodsTypeMap map[string]interface{}, id int64) (domain.GoodsType, bool, error) {
	var goodsType domain.GoodsType
	_, err := configs.Engine.Table("goods_type").Where("id = ?", id).Update(goodsTypeMap)
	if err != nil {
		return goodsType, false, err
	}
	return goodsType, true, nil
}

func DeleteGoodsType(id int64) bool {
	var goodsType domain.GoodsType
	i, err := configs.Engine.Table("goods_type").Where("id = ?", id).Delete(&goodsType)
	if err != nil {
		return false
	}
	return i > 0
}
